/*
 *   Copyright (C) 2009,2010 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	AnalogueRepeaterApp_H
#define	AnalogueRepeaterApp_H

#include "AnalogueRepeaterStatusData.h"
#include "AnalogueRepeaterThread.h"
#include "AnalogueRepeaterConfig.h"
#include "AnalogueRepeaterFrame.h"
#include "AnalogueRepeaterDefs.h"
#include "AnalogueDefines.h"

#include <wx/wx.h>
#include <wx/config.h>

class CAnalogueRepeaterApp : public wxApp {

public:
	CAnalogueRepeaterApp();
	virtual ~CAnalogueRepeaterApp();

	virtual bool OnInit();
	virtual int  OnExit();
	
	virtual void OnInitCmdLine(wxCmdLineParser& parser);
	virtual bool OnCmdLineParsed(wxCmdLineParser& parser);

	// This is overridden because dialog boxes from threads are bad news
#if defined(__WXDEBUG__)
	virtual void OnAssertFailure(const wxChar* file, int line, const wxChar* func, const wxChar* cond, const wxChar* msg);
	virtual void setReader(CWAVFileReader* reader);
#endif

	virtual CAnalogueRepeaterStatusData* getStatus() const;

	virtual void showLog(const wxString& text);

	virtual void setOutputs(bool out1, bool out2, bool out3, bool out4) const;

	virtual void shutdown();
	virtual void startup();
	virtual void timeout();
	virtual void timeReset();
	virtual void command1();
	virtual void command2();

private:
	wxString                 m_name;
	bool                     m_nolog;
	CAnalogueRepeaterFrame*  m_frame;
	CAnalogueRepeaterThread* m_thread;
	CAnalogueRepeaterConfig* m_config;
	wxLogChain*              m_logChain;

	void createThread();
};

DECLARE_APP(CAnalogueRepeaterApp)

#endif
