/*
 *   Copyright (C) 2009,2010 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	AnalogueRepeaterConfigCallsignSet_H
#define	AnalogueRepeaterConfigCallsignSet_H

#include "CWTextCtrl.h"

#include <wx/wx.h>

class CAnalogueRepeaterConfigCallsignSet : public wxPanel {
public:
	CAnalogueRepeaterConfigCallsignSet(wxWindow* parent, int id, const wxString& title, const wxString& callsign, const wxString& beacon, unsigned int speed, unsigned int freq, wxFloat32 level1, wxFloat32 level2);
	virtual ~CAnalogueRepeaterConfigCallsignSet();

	virtual bool Validate();

	virtual wxString     getCallsign() const;
	virtual wxString     getBeacon() const;
	virtual unsigned int getSpeed() const;
	virtual unsigned int getFreq() const;
	virtual wxFloat32    getLevel1() const;
	virtual wxFloat32    getLevel2() const;

private:
	wxString     m_title;
	CCWTextCtrl* m_callsign;
	CCWTextCtrl* m_beacon;
	wxSlider*    m_speed;
	wxSlider*    m_freq;
	wxSlider*    m_level1;
	wxSlider*    m_level2;
};

#endif
