/*
 *   Copyright (C) 2009,2010 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	DStarRepeaterConfig_H
#define	DStarRepeaterConfig_H

#include "DStarDefines.h"

#include <wx/wx.h>
#include <wx/config.h>

class CDStarRepeaterConfig {

public:
	CDStarRepeaterConfig(wxConfigBase* config, const wxString& name);
	~CDStarRepeaterConfig();

	void getCallsign(wxString& callsign, wxString& gateway, DSTAR_MODE& mode, bool& ack) const;
	void setCallsign(const wxString& callsign, const wxString& gateway, DSTAR_MODE mode, bool ack) const;

	void getNetwork(wxString& gatewayAddress, unsigned int& gatewayPort, wxString& localAddress, unsigned int& localPort, unsigned int& networkDelay) const;
	void setNetwork(const wxString& gatewayAddress, unsigned int gatewayPort, const wxString& localAddress, unsigned int localPort, unsigned int networkDelay) const;

	void getRadio(wxString& readDevice, wxString& writeDevice, wxFloat32& level, bool& rxInvert, bool& txInvert) const;
	void setRadio(const wxString& readDevice, const wxString& writeDevice, wxFloat32 level, bool rxInvert, bool txInvert) const;

	void getController(wxString& type, int& pttDelay, bool& pttInvert) const;
	void setController(const wxString& type, int pttDelay, bool pttInvert) const;

	void getTimes(unsigned int& timeout, unsigned int& ackTime) const;
	void setTimes(unsigned int timeout, unsigned int ackTime) const;

	void getControl(bool& enabled, wxString& rpt1Callsign, wxString& rpt2Callsign, wxString& shutdown, wxString& startup, wxString& command1, wxString& command1Line, wxString& command2, wxString& command2Line, wxString& output1, wxString& output2, wxString& output3, wxString& output4) const;
	void setControl(bool enabled, const wxString& rpt1Callsign, const wxString& rpt2Callsign, const wxString& shutdown, const wxString& startup, const wxString& command1, const wxString& command1Line, const wxString& command2, const wxString& command2Line, const wxString& output1, const wxString& output2, const wxString& output3, const wxString& output4) const;

	void getActiveHang(unsigned int& time) const;
	void setActiveHang(unsigned int time) const;

	void getOutputs(bool& out1, bool& out2, bool& out3, bool& out4) const;
	void setOutputs(bool out1, bool out2, bool out3, bool out4) const;

private:
	wxConfigBase* m_config;
	wxString      m_name;
};

#endif
