/*
 *   Copyright (C) 2009,2010 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	DStarRepeaterStatusData_H
#define	DStarRepeaterStatusData_H

#include "DStarDefines.h"

#include <wx/wx.h>

class CDStarRepeaterStatusData {
public:
	CDStarRepeaterStatusData(const wxString& myCall1, const wxString& myCall2, const wxString& yourCall,
							 const wxString& rptCall1, const wxString& rptCall2, unsigned char flag1, unsigned char flag2,
							 unsigned char flag3, bool tx, DSTAR_RX_STATE rxState, DSTAR_RPT_STATE rptState, unsigned int timeoutTimer,
							 unsigned int timeoutExpiry, unsigned int activeTimer, unsigned int activeExpiry);
	~CDStarRepeaterStatusData();

	wxString      getMyCall1() const;
	wxString      getMyCall2() const;
	wxString      getYourCall() const;
	wxString      getRptCall1() const;
	wxString      getRptCall2() const;
	unsigned char getFlag1() const;
	unsigned char getFlag2() const;
	unsigned char getFlag3() const;

	bool          getTX() const;

	DSTAR_RX_STATE  getRxState() const;
	DSTAR_RPT_STATE getRptState() const;

	unsigned int  getTimeoutTimer() const;
	unsigned int  getTimeoutExpiry() const;

	unsigned int  getActiveTimer() const;
	unsigned int  getActiveExpiry() const;

private:
	wxString        m_myCall1;
	wxString        m_myCall2;
	wxString        m_yourCall;
	wxString        m_rptCall1;
	wxString        m_rptCall2;
	unsigned char   m_flag1;
	unsigned char   m_flag2;
	unsigned char   m_flag3;
	bool            m_tx;
	DSTAR_RX_STATE  m_rxState;
	DSTAR_RPT_STATE m_rptState;
	unsigned int    m_timeoutTimer;
	unsigned int    m_timeoutExpiry;
	unsigned int    m_activeTimer;
	unsigned int    m_activeExpiry;
};

#endif
