/*
 *   Copyright (C) 2009,2010 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	DStarRepeaterConfigApp_H
#define	DStarRepeaterConfigApp_H

#include "DStarRepeaterConfigFrame.h"
#include "DStarRepeaterConfigDefs.h"
#include "DStarRepeaterConfig.h"

#include <wx/wx.h>

class CDStarRepeaterConfigApp : public wxApp {

public:
	CDStarRepeaterConfigApp();
	virtual ~CDStarRepeaterConfigApp();

	virtual bool OnInit();
	virtual int  OnExit();
	
	virtual void OnInitCmdLine(wxCmdLineParser& parser);
	virtual bool OnCmdLineParsed(wxCmdLineParser& parser);

	virtual void getCallsign(wxString& callsign, wxString& gateway, DSTAR_MODE& mode, bool& ack) const;
	virtual void setCallsign(const wxString& callsign, const wxString& gateway, DSTAR_MODE mode, bool ack) const;

	virtual void getNetwork(wxString& gatewayAddress, unsigned int& gatewayPort, wxString& localAddress, unsigned int& localPort, unsigned int& networkDelay) const;
	virtual void setNetwork(const wxString& gatewayAddress, unsigned int gatewayPort, const wxString& localAddress, unsigned int localPort, unsigned int networkDelay) const;

	virtual void getRadio(wxString& readDevice, wxString& writeDevice, wxFloat32& level, bool& rxInvert, bool& txInvert) const;
	virtual void setRadio(const wxString& readDevice, const wxString& writeDevice, wxFloat32 level, bool rxInvert, bool txInvert) const;

	virtual void getController(wxString& type, int& pttDelay, bool& pttInvert) const;
	virtual void setController(const wxString& type, int pttDelay, bool pttInvert) const;

	virtual void getTimes(unsigned int& timeout, unsigned int& ackTime) const;
	virtual void setTimes(unsigned int timeout, unsigned int ackTime) const;

	virtual void getControl(bool& enabled, wxString& rpt1Callsign, wxString& rpt2Callsign, wxString& shutdown, wxString& startup, wxString& command1, wxString& command1Line, wxString& command2, wxString& command2Line, wxString& output1, wxString& output2, wxString& output3, wxString& output4) const;
	virtual void setControl(bool enabled, const wxString& rpt1Callsign, const wxString& rpt2Callsign, const wxString& shutdown, const wxString& startup, const wxString& command1, const wxString& command1Line, const wxString& command2, const wxString& command2Line, const wxString& output1, const wxString& output2, const wxString& output3, const wxString& output4) const;

	virtual void getActiveHang(unsigned int& time) const;
	virtual void setActiveHang(unsigned int time) const;

private:
	wxString                   m_name;
	CDStarRepeaterConfigFrame* m_frame;
	CDStarRepeaterConfig*      m_config;
};

DECLARE_APP(CDStarRepeaterConfigApp)

#endif
